#ifndef _MAINDLG_CPP
#define _MAINDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../Resources/Resource.H"

#include "../Source/Entry.H"

#include "../Dialogs/MainDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND hMainDialog_hWnd = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK MainDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HWND hTextEdit_hWnd   = NULL;
    static HWND hTextStatic_hWnd = NULL;

    static HMENU hSystemMenu     = NULL;

    //--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG)
    {
        hMainDialog_hWnd = hWnd;

        hSystemMenu = GetSystemMenu(hWnd, FALSE);
        AppendMenu(hSystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(hSystemMenu, MF_STRING, SYSMENU_ABOUT, "About");

        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

        hTextEdit_hWnd   = GetDlgItem(hWnd, IDC_TEXTBOX);
        hTextStatic_hWnd = GetDlgItem(hWnd, IDC_STATICTEXT);

        SetText(hTextEdit_hWnd, "Text here");
        SetText(hTextStatic_hWnd, "will appear here.");

        CenterWindow(hWnd);

        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {
        if(wParam == IDC_OK) 
        {
            char sText[255];
            GetText(hTextEdit_hWnd, sText, sizeof(sText));
            SetText(hTextStatic_hWnd, sText);
            return TRUE;
        }

        if(wParam == IDC_CANCEL) 
        {
            EndDialog(hWnd, 0);
			hMainDialog_hWnd = NULL;
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        // Any painting should be done here

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_SYSCOMMAND)
    {
        if(LOWORD(wParam) == SYSMENU_ABOUT) //- About (SysMenu Command)
        {
			char sAboutInfo[255];
			sprintf(sAboutInfo, "%s %s\r\n%s - %s", gsTitleCaption, gsFileVersion, __DATE__, __TIME__);
			MessageBox(hWnd, sAboutInfo, gsTitleCaption, 0);
		}
        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE) 
    {
        EndDialog(hWnd, 0);
		hMainDialog_hWnd = NULL;
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

