#ifndef _ENTRY_CPP
#define _ENTRY_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../Resources/Resource.H"

#include "Entry.H"
#include "Init.H"

#include "../Dialogs/MainDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HINSTANCE ghAppInstance = NULL;

char gsAppCopyRight[64];
char gsFileVersion[32];
char gsTitleCaption[64];

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevious, LPSTR CmdLine, int CmdShow)
{
	ghAppInstance = hInstance;

	HANDLE hMutex = NULL;

    if(!InitializeApp())
    {
        return 1;
    }

	if( (hMutex = OpenMutex(SYNCHRONIZE, FALSE, gsTitleCaption)) )
	{
		MessageBox(NULL, "Only one instance can run at a time!", gsTitleCaption, MB_ICONASTERISK + MB_SYSTEMMODAL);
		ReleaseMutex(hMutex);
		CloseHandle(hMutex);
		return 0;
	}
	else hMutex = CreateMutex(0, 0, gsTitleCaption);

    DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialogProc);

    if(!UninitializeApp())
    {
        return 1;
    }

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int GetText(HWND hHandle, char *sOut, int iMaxSize)
{
    int iLen = GetWindowTextLength(hHandle);

    if(iLen > iMaxSize)
	{
		return iLen;
	}

    GetWindowText(hHandle, sOut, iLen + 1);

    sOut[iLen] = '\0';

    return iLen;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void SetText(HWND hHandle, char *sText)
{
    SendMessage(hHandle, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)sText);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CenterWindow(HWND hHandle)
{
    RECT wRect;

    GetWindowRect(hHandle, &wRect);

    DWORD x = (GetSystemMetrics(SM_CXSCREEN) - (wRect.right - wRect.left)) / 2;
    DWORD y = (GetSystemMetrics(SM_CYSCREEN) - (wRect.bottom - wRect.top + GetSystemMetrics(SM_CYCAPTION))) / 2;

    SetWindowPos(hHandle, NULL, x, y, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

